【HDU】5501 dp

 

Problem Description
The SDOI in 2045 is far from what it was been 30 years ago. Each competition has t minutes and n problems.

The ith problem with the original mark of Ai(Ai≤106),and it decreases Bi by each minute. It is guaranteed that it does not go to minus when the competition ends. For example someone solves the ith problem after x minutes of the competition beginning. He/She will get Ai−Bi∗x marks.

If someone solves a problem on x minute. He/She will begin to solve the next problem on x+1 minute.

dxy who attend this competition with excellent strength, can measure the time of solving each problem exactly.He will spend Ci(Ci≤t) minutes to solve the ith problem. It is because he is so godlike that he can solve every problem of this competition. But to the limitation of time, it's probable he cannot solve every problem in this competition. He wanted to arrange the order of solving problems to get the highest mark in this competition.
 

Input
There is an positive integer T(T≤10) in the first line for the number of testcases.(the number of testcases with n>200 is no more than 5)

For each testcase, there are two integers in the first line n(1≤n≤1000) and t(1≤t≤3000) for the number of problems and the time limitation of this competition.

There are n lines followed and three positive integers each line Ai,Bi,Ci. For the original mark,the mark decreasing per minute and the time dxy of solving this problem will spend.


Hint:
First to solve problem 2 and then solve problem 1 he will get 88 marks. Higher than any other order.
 

Output
For each testcase output a line for an integer, for the highest mark dxy will get in this competition.
 

Sample Input
1
4 10
110 5 9
30 2 1
80 4 8
50 3 2
 

Sample Output
88
 

Source
BestCoder Round #59 (div.1)

题意:每道题目有A,B,C三个值,A表示初始分数,B表示每分钟题的分数会减少B,

C表示做这道题需要C分钟,数据保证分数不会变为负数。

现在给出比赛时长,问安排做题的顺序,求最大得分。

 思路:

这道题在动态规划的时候,当前选择做的题的用时对后面做的题的得分有影响,所以dp时必然有前后顺序,所以要么就是状态压缩,要么就是之前就把这些题目排序了,使得后面是有序的。状压不用考虑了因为数据太大,所以我们考虑要如何排序。接下来就是该如何贪心了。
现在有A1,B1,C1和A2,B2,C2这两道题,如果先做1再做2的得分是A1-B1*C1+A2-B2*(C1+C2),如果先做2在做1的得分是A2-B2*C2+A1-B1*(C1+C2),令先做1再做2的得分更高些,那么有A1-B1*C1+A2-B2*(C1+C2) >= A2-B2*C2+A1-B1*(C1+C2),解得B1*C2>=B2*C1所以,只要B1*C2>=B2*C1,那么先做题1再做题2的分数就会更高。
所以,我们只需要根据这个来排序,再做dp,就能得到答案

#include <stdio.h>
#include <string.h>
#include <algorithm>
using namespace std;
struct node{
	int a,b,c;
};
node p[1005];
int dp[3005];
int vis[3005];
int n,m;
bool cmp(node x,node y)           //排序
{
	return x.b*y.c>x.c*y.b;
}
int main()
{
	int T,i,j;
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d%d",&n,&m);
		for(i=1;i<=n;i++)
		{
			scanf("%d%d%d",&p[i].a,&p[i].b,&p[i].c);
		}
		sort(p+1,p+n+1,cmp);
		memset(dp,0,sizeof(dp));
		memset(vis,0,sizeof(vis));      
		for(i=1;i<=n;i++)              //dp
		{
			for(j=m;j>=0;j--)
			{
				if(j>=p[i].c)
				{
					int score=p[i].a-p[i].b*(vis[j-p[i].c]+p[i].c);
					if(dp[j-p[i].c]+score>dp[j])
					{
						dp[j]=dp[j-p[i].c]+score;
						vis[j]=vis[j-p[i].c]+p[i].c;
					}
				}
			}
		}
		printf("%d\n",dp[m]);
	}
	return 0;
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值